wmweather+(1)

NAME
wmweather+ - A dock app for displaying weather information

SYNOPSIS
wmweather+ [options]

DESCRIPTION
wmweather+ downloads current conditions, forecast data, and optionally a radar image. It will also watch for various warnings and display them using an external command.

OPTIONS
Note that later options override earlier ones, and command line options override configuration file options. All multi-character options may be specified with one or two leading dashes. The configuration file is simply one option (with value if necessary) per line, leading dashes optional. Empty lines and lines beginning with the '#' character are ignored.

  General Options

-display <display name>
    Name of display to use.

-c <file>
    Specify a configuration file instead of the default. This option is ignored in the configuration file.

-display-mode <string>
    Specify the starting display mode. Valid values are "cur"/"current", "fcst"/"forecast", and "map"/"radar".

-location <latitude+longitude>
    Specify a latitude and longitude, for example "41'59'00N 87'55'00W" or "N41.9833333333333 W87.9166666666667". You may use either the decimal or DMS notation, with either a prefixed sign or a prefixed or suffixed N/S/E/W. If this option isn't given, the program will assume you live on the equator and guess your longitude based on your system timezone offset.

-e, -email <address>
    Specify the anonymous FTP password.

-v, -version
    Display version number and exit.

-viewer <program>
    External program for viewing weather warnings. This command must take the text to display from standard input. It will be executed as '/bin/sh -c <program>' with stdout redirected to /dev/null. If not specified, it will default to "xless".

-animate, -noanimate
    Turn animation on or off. Animation may still be toggled with the middle mouse button as described below. The default is on.

  Station Options

-s, -station <ID>
    Station ID for all stations. Equivalent to '-metar-station <ID> -avn-station <ID> -eta-station <ID> -mrf-station <ID>'.

-metar-station <ID>
    Station ID for METAR observations. See Current Conditions for more information. A value must be provided.

-avn-station <ID>
    Station ID for AVN forecasts. See Forecasts for more information.

-eta-station <ID>
    Station ID for ETA forecasts. See Forecasts for more information.

-mrf-station <ID>
    Station ID for MRF forecasts. See Forecasts for more information.

-warning-zone <zoneID>
    Zone ID for weather warnings. See Warnings for more information. This option may be repeated for multiple zones.

-forget-warning-zones
    Cause wmweather+ to forget all warning zones found to this point. Useful for user configuration files to override the warning zones specified in the system-wide configuration.

-metar-uri <URI>
-avn-uri <URI>
-eta-uri <URI>
-mrf-uri <URI>
-warning-uri <URI>
    URI to download the specified data from. See URIs for more information.

-metar-post <DATA>
-avn-post <DATA>
-eta-post <DATA>
-mrf-post <DATA>
-warning-post <DATA>
    Post data for downloading the specified data. See URIs for more information. Note that the post option must follow the corresponding URI option. Note that the post data will not be URL-encoded for you.

-noradar
    Do not display a radar image. This is the default.

-radar-uri <URI>
-radar-post <DATA>
    Retrieve an image from the specified URI. See Radar Map for more information.

-radar-crop <string>
    How to crop the radar image. XxY+W+H format. See Radar Map for more information.

-radar-cross <string>
    Where to draw radar crosshairs. XxY format. See Radar Map for more information.

  Measurement Options

-m, -metric
    Same as '-cm -hPa -kph -tempc'.

-in Display precipitation amounts in inches. This is the default.

-cm Display precipitation amounts in centimeters.

-inHg
    Display pressure in inches of mercury. This is the default.

-hPa, -mbar
    Display pressure in hectopascal (millibars)

-mmHg
    Display pressure in millimeters of mercury.

-atm
    Display pressure in atmospheres.

-mph
    Display windspeed in miles/hour. This is the default.

-kph
    Display windspeed in kilometers/hour.

-knots
    Display windspeed in knots.

-mps
    Display windspeed in meters/second.

-beaufort
    Display windspeed on the Beaufort scale.

-tempf
    Display temperature in degrees Fahrenheit. This is the default.

-tempc
    Display temperature in degrees Celcius.

DISPLAY
The dockapp has three display modes: Current Conditions, Forecasts, and Radar Map. Modes are selected by the buttons across the top of the icon. Weather Warning status is indicated by the font color. At any point double-(left)clicking the main display will send SIGUSR1 to the process (see SIGNALS).

  Current Conditions
This mode displays the current conditions as given in the METAR report for the selected station, as downloaded from http://tgftp.nws.noaa.gov/data/observations/metar/stations/ (http://tgftp.nws.noaa.gov/data/observations/metar/stations/) . Downloads are attempted every 15 minutes. Find your station at http://www.nws.noaa.gov/tg/siteloc.shtml (http://www.nws.noaa.gov/tg/siteloc.shtml) .

The station ID is displayed at the top left of the display. The observation date (local) is to the right, and the time (local and UTC) occupies the line below. Under that, to the right is the temperature and relative humidity, the wind direction and speed, the atmospheric pressure (indicated by "P"), the heat index (indicated by "HI"), and the wind chill (indicated by "WC").

To the left is a graphical display of the current weather. The sky condition is indicated as clear (sun), partly cloudy (sun with small clouds), mostly cloudy (sun behind a large cloud), or overcast (large cloud). This image may be covered by fog (foggy overlay), dust/sand/haze (brownish particles), or blowing snow/dust/sand (blue wind-lines), with the level of transparency indicating the degree of visibility. If a funnel cloud or tornado was reported, a tornado graphic will be displayed instead of the sky condition.

Beneath this graphic, icons will depict rain (raindrop), snow (snowflake), freezing precipitation (hailstones), and thunderstorms (lightning bolt). If animation is enabled, the icons will appear and vanish on a ten second cycle to indicate precipitation intensity. Animation may be enabled or disabled by middle-clicking the display.

  Forecasts
This mode displays the current conditions as given in the AVN, ETA, and MRF data for the selected stations, as downloaded from http://www.nws.noaa.gov/tdl/synop/products/bullform.mav.htm (http://www.nws.noaa.gov/tdl/synop/products/bullform.mav.htm) , http://www.nws.noaa.gov/mdl/synop/products/bullform.met.htm (http://www.nws.noaa.gov/mdl/synop/products/bullform.met.htm) and http://www.nws.noaa.gov/tdl/synop/products/bullform.mex.htm (http://www.nws.noaa.gov/tdl/synop/products/bullform.mex.htm) . AVN and ETA reports are downloaded at startup, 0000Z, and 1200Z. MRF reports are downloaded at startup and 0000Z. In the event of failure, downloads will be retried every 15 minutes. See the URIs given to find your stations.

The display is divided into two sections. A small window at the top indicates the date and hour (local time) for which this forecast is valid. Left-clicking this window or clicking the small arrow-button to the right will advance to the next forecast; right-clicking or clicking the small arrow-button to the left will move to the previous forecast. Middle-clicking will return to the first forecast in the list.

The larger display at the bottom shows the forecast for the selected date and time. To the right from top to bottom are the station ID, the daily high and low temperatures, the predicted temperature and relative humidity, and the wind direction and speed. The final line may display the heat index (HI), the wind chill (WC), the amount of snow to fall in that period (SN), the amount of liquid-equivalent precipitation to fall in that period (P), or the forecast type (e.g. "AVN" or "MRF").

To the left is a weather display similar to that for the Current Conditions. The animation here indicates the percent chance of rain, snow, freezing precipitation, thunderstorms, and severe thunderstorms (large lightning bolt). Animation may be turned on or off with the middle button. When animation is off, the mouse wheel may be used to adjust the cutoff chance for the display (hold Shift to adjust faster). The cutoff will be displayed briefly when first turning off animation, when first displaying forecasts, whenever button 6 (typically, the 'side' button) is held down in the large display. Permanent cutoff display may be toggled by double-middle-clicking the large display.

  Radar Map
The radar image will be downloaded every 30 minutes from the URI specified. Then, if -radar-crop was specified in the form XxY+W+H, a subimage of witdh W and height H will be taken, with the upper-left pixel taken from (X, Y). If X or Y is negative, it will be measured from the right/bottom of the image instead of the top/left. The image is then resized to fit within the 52x40 rectangle available. A border around the image indicates the current font color. If -radar-cross was specified in the form XxY, crosshairs will then be drawn over the pixel (X, Y) when the middle button is held on the radar map.

If -noradar was specified or no radar data is available, an image to that effect will be displayed instead.

Some nice images are available from http://weather.noaa.gov/radar/mosaic/DS.p19r0/ar.us.conus.shtml (http://weather.noaa.gov/radar/mosaic/DS.p19r0/ar.us.conus.shtml) and http://www.weather.com/common/home/maps.html (http://www.weather.com/common/home/maps.html) . Be kind, since the display is so small pick the smallest version of the image to download.

  Weather Warnings
Various weather warnings, watches, and statements for the specified zone are downloaded from http://tgftp.nws.noaa.gov/data/watches_warnings/ (http://tgftp.nws.noaa.gov/data/watches_warnings/) . Downloads are attempted at the same time METAR observations are retrieved. Find your zone at http://weather.noaa.gov/ (http://weather.noaa.gov/) or http://weather.gov/ (http://weather.gov/) . Note that some areas issue weather warnings by multiple geopolitical units (e.g. "zones" and "counties"). The -warning-zone option may be specified multiple times, so all appropriate files may be inspected.

If any new warnings are downloaded, all text will be displayed in an orange/red scheme instead of the normal blue/orange. The new warnings may then be viewed by left-clicking the large display window in any mode. At any point, all current warnings may be displayed by right-clicking the large display.

URIs
The URIs from which the various observations, forecasts, and images are downloaded can be easily customized by supplying values for the various -*-uri options. The following substitution variables are available:

%s  The station ID for the specified data type (note that warnings have no station ID).

%z  The zone ID, for warnings.

%f  The warning type, for warnings (e.g. "tornado", "special_weather_stmt").

The substitutions can be manipulated with the standard printf(3) modifiers for strings, in particular the #, 0, -, ' ', +, and ' flags, the field width, and the precision fields are accepted. Also, an additional flag ! is recognized to use the capitalized versions of various numeric flags (e.g. X versus x) and to capitalize character or string values, and an additional syntax ><offset> after the precision is recognized to start at an offset into the string value (negative values indicate offset from the end of the string).

The current defaults are:

metar-uri
    http://tgftp.nws.noaa.gov/data/observations/metar/stations/%s.TXT

avn-uri
    http://www.nws.noaa.gov/cgi-bin/mos/getmav.pl?sta=%s

eta-uri
    http://www.nws.noaa.gov/cgi-bin/mos/getmet.pl?sta=%s

mrf-uri
    http://www.nws.noaa.gov/cgi-bin/mos/getmex.pl?sta=%s

warning-uri
    http://tgftp.nws.noaa.gov/data/watches_warnings/%f/%.2z/%z.txt

FILES

$HOME/.wmweather+/
    Directory used to store downloaded data files. These files may be deleted at any time.

$HOME/.wmweather+/conf
    User configuration.

/etc/wmweather+.conf
    System configuration.

$HOME/.wmweather+/.dir-test
    Created and deleted to test write access to $HOME/.wmweather+/

SIGNALS

SIGUSR1
    Forces downloads for the current mode to be attempted immediately.

SIGUSR2
    Forces all downloads to be attempted immediately.

BUGS
Before reporting a bug, please check the HINTS file (in particular, proxy instructions are in that file). Also, please verify that you have the latest version of wmweather+, and that your bug has not already been reported. Bugs may be filed at http://sourceforge.net/tracker/?group_id=60336&atid=493854 (http://sourceforge.net/tracker/?group_id=60336&atid=493854) .

AUTHORS
wmweather+ was written by Brad Jorsch <anomie@users.sourceforge.net>, using the wmgeneral code by Martijn Pieterse <pieterse@xs4all.nl>.

Email regarding wmweather+ should be sent to anomie@users.sourceforge.net.

INSPIRATION
wmWeather was a good idea, but it didn't give me enough information. However, no code from wmWeather was used in writing wmweather+.